<template>
  <v-list-item
    icon
    dense
    @click="upload"
  >
    <v-list-item-icon>
      <v-icon :class="{ 'upload-transition': transition }" class="upload-icon">
        {{
          completed ? 'mdi-check' : 'mdi-cloud-upload'
        }}
      </v-icon>
    </v-list-item-icon>
    <v-list-item-content>
      <v-list-item-title>
        {{ $t('button.upload-sync') }}
      </v-list-item-title>
    </v-list-item-content>
  </v-list-item>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import type { Client } from '@/client';
import { showSyncUpload } from '@/components/dialogs';
import type { EditableUnit } from '@/data';

@Component
export default class UploadSyncButton extends Vue {
  @Prop()
  client!: Client;

  @Prop()
  path!: string;

  @Prop()
  unit!: EditableUnit;

  completed = false;

  transition = false;

  triggerCompletedTransition() {
    this.transition = true;
    setTimeout(() => {
      this.transition = false;
    }, 500);
  }

  async upload() {
    await showSyncUpload(
      this.client,
      this.path,
      this.unit,
    );
    this.unit.overrideOriginalTable(this.unit.unit.tables[0]);
    this.triggerCompletedTransition();
    setTimeout(() => {
      this.completed = true;
    }, 500);
    setTimeout(() => {
      this.triggerCompletedTransition();
      setTimeout(() => {
        this.completed = false;
      }, 500);
    }, 5000);

    this.$emit('saved');
  }
}
</script>

<style lang="scss" scoped>
.upload {
  &-icon {
    opacity: 1;
    transition: opacity 1s;
  }
  &-transition {
    opacity: 0;
    transition: opacity 1s;
  }
}
</style>
